/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * fetch-generic.h - FetchGenericModule definitions
 *
 * 2005-01-19	new
 */

#ifndef __FETCH_GENERIC_H
#define __FETCH_GENERIC_H

#include <mwcollectd.h>
#include <stdio.h>
#include <curl/curl.h>

using namespace mwcollectd;


class FetchGenericModule : public Module, public ProtocolHandler
{
public:
	FetchGenericModule(MalwareCollector * pCollector);
	virtual ~FetchGenericModule();

	virtual void setLogManager(LogManager * pLogManager) { m_pLogManager = pLogManager; }
	virtual void setConfiguration(Configuration * p, const char * sz) { m_pConfiguration = p; m_szConfigPath = strdup(sz); }

	virtual void start();
	virtual void loop();
	virtual void stop();

	virtual void fetchFile(const char * szUrl);
	virtual bool supportProtocol(const char * szProtocol);

	static size_t WriteCallback(void * pData, size_t nBlocksize, size_t nBlocks, void * pUserData);

protected:
	MalwareCollector * m_pCollector;
	LogManager * m_pLogManager;

	Configuration * m_pConfiguration;
	char * m_szConfigPath;

	CURLM * m_pCurlStack;

	int m_nQueued;
};

typedef struct
{
	FILE * pHandle;
	char * szFileName;
	char * szUrl;
} fetch_generic_info_t;


#endif // __FETCH_GENERIC_H
