/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * config.h - definition of Configuration class (config file parser)
 *
 * 2005-01-05   wrote this one
 */

#ifndef __MWCOLLECTD_CONFIG_H
#define __MWCOLLECTD_CONFIG_H

#include <string>
#include <list>

namespace mwcollectd
{
	typedef struct configuration_node_s
	{
		std::string sName;

		struct // was union but not allowed because of constructor.. :/
		{
			std::string sValue;
			std::list<configuration_node_s *> lpChildren;
		} uData;

		configuration_node_s * pFather; // needed for parsing
		bool bIsLeaf; // has sValue or lpChildren?; an empty block is considered as not beeing leaf!
	} configuration_node_t;


	class Configuration
	{
	public:
		Configuration();
		virtual ~Configuration();

		bool parse(const char * szFile);
		void free();

		virtual const char * getString(const char * szPath, const char * szDefault);
		virtual long getLong(const char * szPath, long lDefault);
		virtual std::list<const char *> * getChildren(const char * szPath);
		virtual bool leafExists(const char * szPath);
		virtual bool blockExists(const char * szPath);

		void statistics(unsigned int& pBlocks, unsigned int& pValues, unsigned int& pCharacters);

	private:
		void freenode(configuration_node_t * pFree); // yeah I love you irc guys ;P

		configuration_node_t * pathToNode(const char * szPath, configuration_node_t * pStart = 0);

	protected:
		configuration_node_t * m_pRoot;

		unsigned int m_nBlocks, m_nValues, m_nCharacters; // statisitics are always cool
	};

}

#endif // __MWCOLLECTD_CONFIG_H
