/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * log-irc.h - log-irc module header
 *
 * 2005-01-06	 started irc logging module
 */

#ifndef __MWCOLLECTD_REPORT_IRC_H
#define __MWCOLLECTD_REPORT_IRC_H

#include <mwcollectd.h>

using namespace mwcollectd;

#define IRC_USER "mwcollect2"

class ReportIrcModule : public mwcollectd::Module, public mwcollectd::BasicLogger
{
public:
	ReportIrcModule(mwcollectd::NetworkInterface * pNetIface);
	virtual ~ReportIrcModule();

	virtual void setLogManager(LogManager * pLogManager);
	virtual void setConfiguration(Configuration * pConfig, const char * szPath);

	virtual void start();
	virtual void loop(); // for reconnect retries
	virtual void stop();

	virtual void log(mwcollectd::log_level_t llLevel, const char * szMessage);
	virtual void setLogLevel(mwcollectd::log_level_t llLevel) { m_llLevel = llLevel; }

	void startForwarding();
	void connectionLost();

protected:
	mwcollectd::LogManager * m_pLogger;
	mwcollectd::NetworkInterface * m_pNetworkInterface;
	Configuration * m_pConfig;

	int m_iSocket;
	mwcollectd::log_level_t m_llLevel;

	char * m_szConfigPath;

	bool m_bRetry; // retry connection in ::connectionLost()
	unsigned long m_ulNextTry;

	const char * m_szChannel;
};

typedef struct
{
	char szBuffer[514];
	unsigned short usBufferPos;
	bool fOnChannel;

	ReportIrcModule * pModule;
	mwcollectd::LogManager * pLogger;
	mwcollectd::NetworkInterface * pInterface;
	Configuration * pConfig;

	char * szChannel, * szKey, * szPassword, * szNick;
	char * szAdminNick, * szAdminUser, * szAdminHost;
} irc_state_t;

void IrcConnectedNotifier(int iHandle, unsigned short usDestPort, void * pUserData);
void IrcIncomingNotifier(int iHandle, unsigned char * pucPacketData, unsigned int nPacketLength, void * pParam);
void IrcTerminationNotifier(bool bServer, void * pParam);

#endif
