/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * coordinator.cpp - Creates the Port 135 Port listener and delegates stuff to substuff :)
 *
 * 2005-01-19	new
 */

#include "vuln-win32rpc.h"


extern "C"
{
	mwcollectd::Module * __attribute__ ((dllexport)) CreateInstance(mwcollectd::MalwareCollector * pCollector)
	{
		return new RpcCoordinator(pCollector);
	}
}


RpcCoordinator::RpcCoordinator(MalwareCollector * pCollector)
{
	m_pCollector = pCollector;
}

RpcCoordinator::~RpcCoordinator()
{
	free(m_szConfigPath);
}


void RpcCoordinator::start()
{
	long lPort;

	{
		char * szPath;

		asprintf(&szPath, "%s:port", m_szConfigPath);
		lPort = m_pConfiguration->getLong(szPath, 135);
		free(szPath);
	}

	if(!(m_iServerSocket = m_pCollector->getNetworkInterface()->createSocket(lPort, RpcCoordinator::ConnectionNotifier, RpcCoordinator::IncomingWrapper, RpcCoordinator::TerminationNotifier, this)) < 0)
		m_pLogManager->log(LL_CRITICAL, "Could not create DCOM Socket!");
}

void RpcCoordinator::stop()
{
	if(m_iServerSocket > 0)
		m_pCollector->getNetworkInterface()->closeSocket(m_iServerSocket);
}



void * RpcCoordinator::ConnectionNotifier(int iHandle, unsigned long ulSourceAddress, unsigned short usSourcePort, unsigned short usLocalPort, void * pUserData)
{
	RpcSession * pSession = ((RpcCoordinator *) pUserData)->createSession();

	pSession->etablishedConnection(ulSourceAddress, usSourcePort, usLocalPort);
	return pSession;
}

void RpcCoordinator::IncomingWrapper(int iHandle, unsigned char * pucPacketData, unsigned int nPacketLength, void * pUserData)
{                                           
    ((RpcSession *) pUserData)->incomingData(iHandle, pucPacketData, nPacketLength);
}

void RpcCoordinator::TerminationNotifier(bool bServer, void * pUserData)
{                                                              
	if(!bServer)
	{
		((RpcSession *) pUserData)->connectionTerminated();
	
		delete ((RpcSession *) pUserData);
	}
}
