/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * vuln-dcom.h - Definitions for the whole port 135 vulnerability stuffz0r
 *
 * 2005-01-19	new
 */

#ifndef __VULN_DCOM_H
#define __VULN_DCOM_H

#include <mwcollectd.h>

using namespace mwcollectd;


typedef enum
{
	RPCS_CONNECTED = 0,
	RPCS_GOT_DCOM_BINDSTR,

	RPCS_GOT_LSASS_STAGE1,
	RPCS_GOT_LSASS_STAGE2,
	RPCS_GOT_LSASS_STAGE3,
	RPCS_GOT_LSASS_STAGE4,
	RPCS_GOT_LSASS_STAGE5,
	RPCS_GOT_LSASS_STAGE6,

	RPCS_OBSOLETE,
} rpc_state_t;

class RpcSession
{
public:
	RpcSession(MalwareCollector * pCollector, LogManager * pLogManager);
	virtual ~RpcSession();

	virtual void etablishedConnection(unsigned long ulSource, unsigned short usSourcePort, unsigned short usLocalPort);
	virtual void incomingData(int iHandle, unsigned char * pucData, unsigned int nLength);
	virtual void connectionTerminated();

protected:
	MalwareCollector * m_pCollector;
	LogManager * m_pLogManager;

	rpc_state_t m_dsState;
	unsigned long m_ulSource;
	unsigned short m_usLocalPort;
};

class RpcCoordinator : public Module
{
public:
	RpcCoordinator(MalwareCollector * pCollector);
	virtual ~RpcCoordinator();

	virtual void setLogManager(LogManager * pLogManager) { m_pLogManager = pLogManager; }
	virtual void setConfiguration(Configuration * p, const char * sz) { m_pConfiguration = p; m_szConfigPath = strdup(sz); }

	virtual void start();
	virtual void stop();

	RpcSession * createSession() { return new RpcSession(m_pCollector, m_pLogManager); } // facility call used in connection notifier

	static void * ConnectionNotifier(int iHandle, unsigned long ulSourceAddress, unsigned short usSourcePort, unsigned short usLocalPort, void * pUserData);
	static void IncomingWrapper(int iHandle, unsigned char * pucPacketData, unsigned int nPacketLength, void * pUserData);
	static void TerminationNotifier(bool bServer, void * pUserData);

protected:
	MalwareCollector * m_pCollector;
	LogManager * m_pLogManager;

	Configuration * m_pConfiguration;
	char * m_szConfigPath;

	int m_iServerSocket;
};


#endif // __VULN_DCOM_H
