/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * coordinator.cpp - Creates the Port 42 Port listener and delegates stuff to substuff :)
 *
 * 2005-01-19	new
 */

#include "wins.h"


extern "C"
{
	mwcollectd::Module * __attribute__ ((dllexport)) CreateInstance(mwcollectd::MalwareCollector * pCollector)
	{
		return new WinsCoordinator(pCollector);
	}
}


WinsCoordinator::WinsCoordinator(MalwareCollector * pCollector)
{
	m_pCollector = pCollector;
}

WinsCoordinator::~WinsCoordinator()
{
	free(m_szConfigPath);
}


void WinsCoordinator::start()
{
	long lPort;

	{
		char * szPath;

		asprintf(&szPath, "%s:port", m_szConfigPath);
		lPort = m_pConfiguration->getLong(szPath, 42);
		free(szPath);
	}

	if(!(m_iServerSocket = m_pCollector->getNetworkInterface()->createSocket(lPort, WinsCoordinator::ConnectionNotifier, WinsCoordinator::IncomingWrapper, WinsCoordinator::TerminationNotifier, this)) < 0)
		m_pLogManager->log(LL_CRITICAL, "Could not create DCOM Socket!");
}

void WinsCoordinator::stop()
{
	if(m_iServerSocket > 0)
		m_pCollector->getNetworkInterface()->closeSocket(m_iServerSocket);
}



void * WinsCoordinator::ConnectionNotifier(int iHandle, unsigned long ulSourceAddress, unsigned short usSourcePort, unsigned short usLocalPort, void * pUserData)
{
	WinsSession * pSession = ((WinsCoordinator *) pUserData)->createSession();

	pSession->etablishedConnection(ulSourceAddress, usSourcePort, usLocalPort);
	return pSession;
}

void WinsCoordinator::IncomingWrapper(int iHandle, unsigned char * pucPacketData, unsigned int nPacketLength, void * pUserData)
{
	((WinsSession *) pUserData)->incomingData(iHandle, pucPacketData, nPacketLength);
}

void WinsCoordinator::TerminationNotifier(bool bServer, void * pUserData)
{
	if(!bServer)
	{
		((WinsSession *) pUserData)->connectionTerminated();	
	
		delete ((WinsSession *) pUserData);
	}
}
