/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * wins.h	win2k wins vulnerability (:42), still TODO
 *
 */

#ifndef __VULN_WINS_H
#define __VULN_WINS_H

#include <mwcollectd.h>


using namespace mwcollectd;

typedef enum
{
	WINSS_NONE = 0,
	WINSS_RECEIVED_BINDSTR,
} wins_state_t;

class WinsSession
{
public:
	WinsSession(MalwareCollector * pCollector, LogManager * pLogManager);
	virtual ~WinsSession();

	virtual void etablishedConnection(unsigned long ulSource, unsigned short usSourcePort, unsigned short usLocalPort);
	virtual void incomingData(int iHandle, unsigned char * pucData, unsigned int nLength);
	virtual void connectionTerminated();

protected:
	MalwareCollector * m_pCollector;
	LogManager * m_pLogManager;

	wins_state_t m_wsState;
	unsigned long m_ulSource;
	unsigned short m_usLocalPort;
};

class WinsCoordinator : public Module
{
public:
	WinsCoordinator(MalwareCollector * pCollector);
	virtual ~WinsCoordinator();

	virtual void setLogManager(LogManager * pLogManager) { m_pLogManager = pLogManager; }
	virtual void setConfiguration(Configuration * p, const char * sz) { m_pConfiguration = p; m_szConfigPath = strdup(sz); }

	virtual void start();
	virtual void stop();

	WinsSession * createSession() { return new WinsSession(m_pCollector, m_pLogManager); } // facility call used in connection notifier

	static void * ConnectionNotifier(int iHandle, unsigned long ulSourceAddress, unsigned short usSourcePort, unsigned short usLocalPort, void * pUserData);
	static void IncomingWrapper(int iHandle, unsigned char * pucPacketData, unsigned int nPacketLength, void * pUserData);
	static void TerminationNotifier(bool bServer, void * pUserData);

protected:
	MalwareCollector * m_pCollector;
	LogManager * m_pLogManager;

	Configuration * m_pConfiguration;
	char * m_szConfigPath;

	int m_iServerSocket;
};

#endif
