/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * mwcollectd.h - definition of MalwareCollector, includes slave headers
 *
 * 2004-12-28	 basic layout
 * 2005-01-05	 added logging header
 */

#ifndef __MWCOLLECTD_MWCOLLECTD_H
#define __MWCOLLECTD_MWCOLLECTD_H

#include "log.h"
#include "config.h"
#include "modules.h"
#include "network.h"
#include "dispatch.h"
#include "shell.h"

#include <list>

namespace mwcollectd
{
	class MalwareCollector
	{
	public:
		MalwareCollector();
		virtual ~MalwareCollector();

		void setConfiguration(Configuration * pConfig);
		void setLogManager(LogManager * pLogManager);

		void start();
		void loop();
		void stop();
		bool active();

		static int run(int iArgC, char * * szArgV);

		virtual NetworkInterface * getNetworkInterface();

		virtual SubmissionDispatcher * getSubmissionDispatcher();
		virtual FetchDispatcher * getFetchDispatcher();
		virtual ShellcodeDispatcher * getShellcodeDispatcher() { return m_pShellcodeDispatcher; }
		virtual ShellEmulation * getShell() { return m_pShell; }

	protected:

		bool loadModules();
		bool loadSingleModule(const char * szName);

	private:
		Configuration * m_pConfiguration;
		LogManager * m_pLogManager;
		NetworkInterface * m_pNetworkInterface;

		SubmissionDispatcher * m_pSubmissionDispatcher;
		FetchDispatcher * m_pFetchDispatcher;
		ShellcodeDispatcher * m_pShellcodeDispatcher;

		ShellEmulation * m_pShell;

		std::list<ModuleRepresentation> m_lmModules;

		bool m_bActive;
	};
}

#endif // __MWCOLLECTD_MWCOLLECTD_H
