/* mwcollect2 (c) 2004-2005 Honeynet Project
 * this code is licensed under the BSD License, the the file LICENSE for details
 *
 * parser.cpp	the simple generic libpcre based bot shellcode parser biatsch
 *
 * 2005-02-06	woo teh fack ar yu?
 */

#include "scpgb.h"

extern "C"
{
  mwcollectd::Module * __attribute__ ((dllexport)) CreateInstance(mwcollectd::MalwareCollector * pCollector)
  {
    return (new GenericBotShellcodeParser(pCollector));
  }
}

GenericBotShellcodeParser::GenericBotShellcodeParser(MalwareCollector * pCollector)
{
	m_pCollector = pCollector;
}

GenericBotShellcodeParser::~GenericBotShellcodeParser()
{
}

void GenericBotShellcodeParser::compilePatterns(pcre * * * pppPatterns, const char * * pszPatterns, unsigned int nPatterns)
{
	* pppPatterns = (pcre * *) malloc(sizeof(pcre *) * nPatterns);

	for(unsigned int i = 0; i < nPatterns; ++i)
	{
		const char * szError;
		int iErrorPos;

		if(!((* pppPatterns)[i] = pcre_compile(pszPatterns[i], PCRE_DOTALL, &szError, &iErrorPos, 0)))
			m_pLogManager->log(LL_CRITICAL, "PCRE Pattern \"%s\" does not compile: %s @ %u", pszPatterns[i], szError, iErrorPos);
	}
}


void GenericBotShellcodeParser::start()
{
	const char * pszPatterns[] = {
		"^.*\\xEB.\\xEB.\\xE8.*\\xB1(.).*\\x80..(.).*\\xE2.(.*)$", // generic xor decoder
		"^.*\\x0A\\x65\\x73\\x73.*\\x57\\xE8....(.*)\\x6A.\\xE8....+$", // some generic createprocess shellcode
		"^.*\\xEB.((http|https|ftp):\\/\\/.*?)\\xDF+.*$", // generic prepended url shellcode
		"^.*(\\xEB\\x10\\x5B\\x4B\\x33\\xC9\\x66\\xB9\\x25\\x01\\x80\\x34\\x0B\\x99\\xE2\\xFA\\xEB\\x05\\xE8\\xEB\\xFF\\xFF\\xFF\\x70\\x62\\x99\\x99\\x99\\xC6\\xFD.*\\xF9\\x7E\\xE0\\x5F\\xE0).*$", // house of dabus connect_back
		"^.*(\\xEB\\x10\\x5A\\x4A\\x33\\xC9\\x66\\xB9\\x7D\\x01\\x80\\x34\\x0A\\x99\\xE2\\xFA\\xEB\\x05\\xE8\\xEB\\xFF\\xFF\\xFF\\x70\\x95\\x98\\x99\\x99\\xC3\\xFD.*\\x99\\xFA\\xF5\\xF6\\xEA\\xFC\\xEA\\xF6\\xFA\\xF2\\xFC\\xED\\x99).*$" // house of dabus listen_shell
		};

	compilePatterns(&m_ppPatterns, pszPatterns, 5);

	m_pCollector->getShellcodeDispatcher()->addShellcodeParser(this);
}

void GenericBotShellcodeParser::stop()
{
	free(m_ppPatterns);
}


bool GenericBotShellcodeParser::parseShellcode(unsigned char * pucShellcode, unsigned int nLength, unsigned long ulSource)
{
	bool bMatch = false, bDecodingPerformed = false;
	unsigned char * pucDecoded = pucShellcode;
	unsigned int nDecodedLength = nLength;
	int piOutput[10 * 3];
	int iResult; // for the whole pcre shit baby :D

	{ // decoding (xor et al.)
		if((iResult = pcre_exec(m_ppPatterns[0], 0, (char *) pucShellcode, nLength, 0, 0, piOutput, sizeof(piOutput))) > 0)
		{ // ok we have generic xor decoder
			const char * pKey, * pCodeLength;

			pcre_get_substring((char *) pucShellcode, piOutput, iResult, 1, &pCodeLength);
			pcre_get_substring((char *) pucShellcode, piOutput, iResult, 2, &pKey);			

			nDecodedLength = piOutput[7] - piOutput[6];
			pucDecoded = (unsigned char *) malloc(nDecodedLength);

			for(unsigned int i = 0; i < nDecodedLength; ++i)
				pucDecoded[i] = (i < (* ((unsigned char *) pCodeLength)) ? pucShellcode[i + piOutput[6]] ^ * ((unsigned char *) pKey) : pucShellcode[i + piOutput[6]]);

			m_pLogManager->log(LL_DEBUG, "Detected generic XOR Decoder, key is %xh, code is %xh (%xh) bytes long.", * ((unsigned char *) pKey), * ((unsigned char *) pCodeLength), piOutput[7] - piOutput[6]);

			pcre_free_substring(pCodeLength);
			pcre_free_substring(pKey);

			bDecodingPerformed = true;
		}
	}
	
	{ // actual parsing
		if((iResult = pcre_exec(m_ppPatterns[1], 0, (char *) pucDecoded, nDecodedLength, 0, 0, piOutput, sizeof(piOutput))) > 0)
		{
			const char * pRemoteCommand;

			pcre_get_substring((char *) pucDecoded, piOutput, iResult, 1, &pRemoteCommand);
			
			m_pLogManager->log(LL_DEBUG, "Detected generic CreateProcess Shellcode: \"%s\"", pRemoteCommand);

			{
				ShellSession * pSession;

				pSession = m_pCollector->getShell()->createSession(ulSource);
				m_pCollector->getShell()->executeCommand((char *) pRemoteCommand, pSession);
				m_pCollector->getShell()->destroySession(pSession);
			}

			pcre_free_substring(pRemoteCommand);

			bMatch = true;
		}

		if((iResult = pcre_exec(m_ppPatterns[2], 0, (char *) pucDecoded, nDecodedLength, 0, 0, piOutput, sizeof(piOutput))) > 0)
		{
			const char * pUrl;

			pcre_get_substring((char *) pucDecoded, piOutput, iResult, 1, &pUrl);

			m_pLogManager->log(LL_DEBUG, "Detected generic prepended unencoded URL Shellcode: \"%s\"", pUrl);
			m_pCollector->getFetchDispatcher()->fetchFile(pUrl);

			pcre_free_substring(pUrl);

			bMatch = true;
		}

		if((iResult = pcre_exec(m_ppPatterns[3], 0, (char *) pucDecoded, nDecodedLength, 0, 0, piOutput, sizeof(piOutput))) > 0)
		{
			const char * pCode;
			unsigned long ulAddress;
			unsigned short usPort;

			pcre_get_substring((char *) pucDecoded, piOutput, iResult, 1, &pCode);

			ulAddress = * ((unsigned long *) &pCode[111]) ^ 0x99999999;
			usPort = ntohs(* ((unsigned short *) &pCode[118]) ^ 0x9999);

			m_pLogManager->log(LL_DEBUG, "Detected HoD connectback shellcode, %08X:%u.", ulAddress, usPort);
			m_pCollector->getShell()->connectSession(ulAddress, usPort);

			pcre_free_substring(pCode);

			bMatch = true;
		}

		if((iResult = pcre_exec(m_ppPatterns[4], 0, (char *) pucDecoded, nDecodedLength, 0, 0, piOutput, sizeof(piOutput))) > 0)
		{
			const char * pCode;
			unsigned short usPort;

			pcre_get_substring((char *) pucDecoded, piOutput, iResult, 1, &pCode);

			usPort = ntohs(* ((unsigned short *) &pCode[176]) ^ 0x9999);

			m_pLogManager->log(LL_DEBUG, "Detected HoD listenshell shellcode, :%u.", usPort);
			m_pCollector->getShell()->listenSession(usPort);

			pcre_free_substring(pCode);

			bMatch = true;
		}
	}
	
	
	if(bDecodingPerformed)
		free(pucDecoded);	

	return bMatch;
}
